###############################################################################
# EditAliases.pl                                                              #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub ViewAliases
{$INFO{list}+=0;
if ($INFO{list}<0 || $INFO{list}>1)
{$INFO{list}=0;
}if (!hasPermission('admin_aliases' . $INFO{list}))
{fatal_error('nopermission');
}my $prefix;
my %hash;
if ($INFO{list}==0)
{$prefix = 'commandaliases_';
%hash = %alias;
}else
{$prefix = 'coloraliases_';
%hash = %color;
}my $output = <<"EOT";
<tr>
<th><b>$text{$prefix . 'alias'}</b></th>
<th><b>$text{$prefix . 'command'}</b></th>
<th>&nbsp;</th>
</tr>
EOT
foreach my $key (sort keys %hash)
{my $escaped=escape($key);
$output .= <<"EOT";
<tr id="table2">
<td>$key</td>
<td>$hash{$key}</td>
<td><a href="$cgi&action=modifyalias&list=$INFO{list}&name=$escaped">$text{$prefix . 'alias_modify'}</a></td>
</tr>
EOT
}$output .= <<"EOT";
<tr id="table2">
<td colspan=3 align=center><a href="$cgi&action=modifyalias&list=$INFO{list}">$text{$prefix . 'createnew'}</a></td>
</tr>
</table>
</td></tr>
EOT
printheader("popup","",('{TITLE}' => $text{$prefix . 'title'},
'{ROWS}' => $output,
'{COMMENT}' => $text{$prefix . 'comment'}));
exitprog();
}sub ModifyAlias
{$INFO{list}+=0;
if ($INFO{list}<0 || $INFO{list}>1)
{$INFO{list}=0;
}if (!hasPermission('admin_aliases' . $INFO{list}))
{fatal_error('nopermission');
}my $prefix1;
my $prefix2;
my $prefix3;
my %hash;
if ($INFO{list}==0)
{$prefix1 = 'modifycommandalias_';
$prefix2 = 'deletecommandalias_';
$prefix3 = 'commandaliases_';
%hash = %alias;
}else
{$prefix1 = 'modifycoloralias_';
$prefix2 = 'deletecoloralias_';
$prefix3 = 'coloraliases_';
%hash = %color;
}my $modify = 0;
my $name = "<input type=text name=name size=20 maxlength=20 style=\"width=100%\">";
my $command = "";
my $delete = "";
if ($INFO{name} ne "")
{if (!exists($hash{$INFO{name}}))
{fatal_error('unknownalias',$INFO{name});
}$modify = 1;
$name = "$INFO{name}<input type=hidden name=name value=\"$INFO{name}\">";
$command = $hash{$INFO{name}};
$delete = "<input type=submit onClick=\"form.action.value='deletealias'\" value=\"$text{$prefix2 . 'submit'}\">";
ToHTML($command);
}printheader("popup","{ROWS}",('{TITLE}' => $text{$prefix1 . 'title'},
'{COMMENT}' => $text{$prefix1 . 'comment'}));
output(<<"EOT");
<tr><th>$text{$prefix1 . 'title'}</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST action="$cgi">
<input type=hidden name=action value="modifyalias2">
<input type=hidden name=list value=$INFO{list}>
<input type=hidden name=modify value=$modify>
<tr>
<td nowrap><b>$text{$prefix3 . 'alias'}:</b></td>
<td width=100%>$name</td>
</tr>
<tr>
<td nowrap><b>$text{$prefix3 . 'command'}:</b></td>
<td><input type=text name=command size=20 maxlength=50 value="$command" style="width=100%"></td>
</tr>
<tr>
<td colspan=2 align=center>
<input type=submit onClick="form.action.value='modifyalias2'" value="$text{$prefix1 . 'submit'}">
$delete
</td>
</tr>
</table>
</td></tr>
</form>
</table></td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => $text{$prefix1 . 'title'},
'{COMMENT}' => $text{$prefix1 . 'comment'}));
exitprog();
}sub ModifyAlias2
{$FORM{list}+=0;
if ($FORM{list}<0 || $FORM{list}>1)
{$FORM{list}=0;
}if (!hasPermission('admin_aliases' . $FORM{list}))
{fatal_error('nopermission');
}trim($FORM{name});
my %hash;
if ($FORM{list}==0)
{%hash = %alias;
fatal_error('noaliasgiven') if ($FORM{name} eq "");
$FORM{name} =~ s/\s/_/g;
fatal_error('illegalalias') if ($FORM{name} !~ /^\//);
}else
{%hash = %color;
fatal_error('noaliasgiven') if ($FORM{name} eq "");
$FORM{name} =~ s/\s/_/g;
fatal_error('illegalalias_color') if ($FORM{command} =~ /[^a-zA-z0-9\#\_]/);
}if ($FORM{modify}!=0)
{if (!exists($hash{$FORM{name}}))
{fatal_error('unknownalias',$FORM{name});
}}else
{if (exists($hash{$FORM{name}}))
{fatal_error('aliasexists',$FORM{name});
}}$hash{$FORM{name}} = $FORM{command};
if ($FORM{list}==0)
{%alias = %hash;
}else
{%color = %hash;
}writeSettingsFile();
output("Location: $cgi&action=viewaliases&list=$FORM{list}\n\n");
}sub DeleteAlias
{$FORM{list}+=0;
if ($FORM{list}<0 || $FORM{list}>1)
{$FORM{list}=0;
}if (!hasPermission('admin_aliases' . $FORM{list}))
{fatal_error('nopermission');
}trim($FORM{name});
my %hash;
if ($FORM{list}==0)
{fatal_error('noaliasgiven') if ($FORM{name} eq "");
$FORM{name} =~ s/\s/_/g;
fatal_error('illegalalias') if ($FORM{name} !~ /^\//);
if (!exists($alias{$FORM{name}}))
{fatal_error('unknownalias',$FORM{name});
}delete $alias{$FORM{name}};
}else
{%hash = %color;
fatal_error('noaliasgiven') if ($FORM{name} eq "");
$FORM{name} =~ s/\s/_/g;
if (!exists($color{$FORM{name}}))
{fatal_error('unknownalias',$FORM{name});
}delete $color{$FORM{name}};
}writeSettingsFile();
output("Location: $cgi&action=viewaliases&list=$FORM{list}\n\n");
}1;
