###############################################################################
# EditMessages.pl                                                             #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub ViewMessages
{if (!hasPermission('admin_messages'))
{fatal_error('nopermission');
}require "$language.descr";
printheader("popup","{ROWS}",('{TITLE}' => $text{messages_title},
'{COMMENT}' => $text{messages_comment}));
output(<<"EOT");
<tr>
<th><b>$text{messages_name}</b></th>
<th><b>$text{messages_text}</b></th>
<th>&nbsp;</th>
</tr>
EOT
foreach my $entry (sort keys %message)
{@lines=split(/\n/,$message{$entry});
my $rowspan = (@lines>0?@lines:1);
ToHTML($lines[0]);
my $description=getDescription($entry);
output(<<"EOT");
<tr id="table2">
<td rowspan=$rowspan>$entry$description<br><a href="$cgi&action=modifymessage&name=$entry&num=-1">$text{messages_createnew}</a></td>
<td>$lines[0]&nbsp;</td>
<td><a href="$cgi&action=modifymessage&name=$entry&num=0">$text{messages_message_modify}</a></td>
</tr>
EOT
for(my $i=1;$i<@lines;$i++)
{ToHTML($lines[$i]);
output(<<"EOT");
<tr id="table2">
<td>$lines[$i]&nbsp;</td>
<td><a href="$cgi&action=modifymessage&name=$entry&num=$i">$text{messages_message_modify}</a></td>
</tr>
EOT
}}output(<<"EOT");
</table>
</td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => $text{messages_title},
'{COMMENT}' => $text{messages_comment}));
exitprog();
}sub ModifyMessage
{if (!hasPermission('admin_messages'))
{fatal_error('nopermission');
}if (!exists($message{$INFO{name}}))
{fatal_error('unknownmessage',$INFO{name});
}my $delete="";
my $title=$text{createmessage_title};
my $text="";
if ($INFO{num} >= 0)
{$delete="<input type=submit onClick=\"form.action.value='deletemessage'\" value=\"$text{deletemessage_submit}\">";
$title=$text{modifymessage_title};
my @lines=split(/\n/,$message{$INFO{name}});
if ($INFO{num}>=@lines)
{$INFO{num} = (@lines>0?0:@lines-1);
}$text=$lines[$INFO{num}];
if (@lines<2)
{$delete="";
}}printheader("popup","{ROWS}",('{TITLE}' => $title,
'{COMMENT}' => $text{modifymessage_comment}));
output(<<"EOT");
<tr><th>$title</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST action="$cgi">
<input type=hidden name=action value="modifymessage2">
<input type=hidden name=num value="$INFO{num}">
<tr>
<td><b>$text{messages_name}:</b></td>
<td>$INFO{name}<input type=hidden name=name value="$INFO{name}"></td>
</tr>
<tr>
<td valign=top><b>$text{messages_text}:</b></td>
<td width=100%><textarea name="text" cols=35 rows=6 style="width:100%">$text</textarea></td>
</tr>
<tr>
<td colspan=2 align=center>
<input type=submit onClick="form.action.value='modifymessage2'" value="$text{modifymessage_submit}">
$delete
</td>
</tr>
</table>
</td></tr>
</form>
</table></td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => $title,
'{COMMENT}' => $text{modifymessage_comment}));
exitprog();
}sub ModifyMessage2
{if (!hasPermission('admin_messages'))
{fatal_error('nopermission');
}if (!exists($message{$FORM{name}}))
{fatal_error('unknownmessage',$FORM{name});
}$FORM{text} =~ s/\n/ /g;
if ($FORM{text} !~ /\S/)
{fatal_error('messages_notextgiven');
}my @lines=split(/\n/,$message{$FORM{name}});
if ($FORM{num}<0)
{push(@lines,$FORM{text});
}else
{if ($FORM{num}>=@lines)
{$FORM{num} = (@lines>0?0:@lines-1);
}$lines[$FORM{num}]=$FORM{text};
}$message{$FORM{name}}=join("\n",@lines);
writeLanguageFile();
output("Location: $cgi&action=viewmessages\n\n");
}sub DeleteMessage
{if (!hasPermission('admin_messages'))
{fatal_error('nopermission');
}if (!exists($message{$FORM{name}}))
{fatal_error('unknownmessage',$FORM{name});
}my @lines=split(/\n/,$message{$FORM{name}});
if (@lines<2)
{fatal_error('lastmessage');
}if ($FORM{num}>=0 && $FORM{num}<@lines)
{splice(@lines,$FORM{num},1);
$message{$FORM{name}}=join("\n",@lines);
writeLanguageFile();
}output("Location: $cgi&action=viewmessages\n\n");
}1;
