###############################################################################
# Receive.pl                                                                  #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
my $end = 0;
my $alive = time;
my %room;
my @ignorelist=();
sub Receive
{$SIG{TERM} = sub { ConnectionBroken(); };
Login();
my @onlineinfo=getonlineinfo($user{name});
if (defined($onlineinfo[0]))                # already logged in
{my $text=CommandToText(command => 'quit',
name => $onlineinfo[0],
text => getMessage('out_chat',$user{nick},$chatname),
room => $onlineinfo[2],
id => $onlineinfo[4]);
OutputCommand($text);
}$user{ipcid} = msgget($IPC_PRIVATE,0600);
if (!defined($user{ipcid}))
{fatal_error('ipcerror');
}%room=getroominfo($user{room});
my $text=CommandToText(command => 'login',
name => $user{name},
room => $user{room},
text => getMessage('in_chat',$user{nick},$chatname));
OutputCommand($text);
writeonlineinfo(1,$user{name},$user{nick},$user{room},$user{ipcid},$INFO{id});
if ($INFO{pull} != 0)
{my $pid = fork();
if ($pid != 0)
{printheader("script","",('{SCRIPT}' => "cgi=\"$cgi\";updateRefresh()"));
exitprog;
}$queue = 1;
open(STDIN,"/dev/null");
open(STDOUT,">/dev/null");
}printheader("messages","{MESSAGES}");
my $greeting = MakeGreeting($room{income}) . "<br>\n";
$greeting .= getMessage('greeting_welcome',$room{name}) . "<br>\n";
$greeting .= getMessage('greeting_topic',$room{topic}) . "<br>\n";
ToHTML($room{topic});
output(<<"EOT") || ConnectionBroken();
<script>
updateInput();
updateUserList();
updateOptions();
updateRoomList2();
</script>
$greeting<br>
EOT
select (STDOUT);
$| = 1;
$SIG{ALRM} = sub
{(time - $lastalive < $alive_test_rate) || ConnectionBroken();
output("\n") || ConnectionBroken();
alarm($alive_test_rate);
};
alarm($alive_test_rate);
my $command = "";
while ($end != 1)
{msgrcv($user{ipcid},$command,1024,0,0);
(my $dummy,$command) = unpack("La*",$command);
my $output=getOutput($command);
if ($output ne "")
{output($output) || ConnectionBroken();
}}Logout();
}sub getOutput
{my %data = TextToCommand($_[0]);
if ($data{command} eq 'text')
{if (ignored($data{name}) != 0)
{return "";
}if ($data{name} eq $user{name})
{$lastalive = time;
}ConvertText($data{text},1);
my $to="";
if ($data{tonick} ne "")
{$to = "";
foreach my $nick (split(/\s/,$data{tonick}))
{$to .= "$nick, ";
}$to =~ s/,\s$//;
$to=" (" . sprintf("$text{text_tagto}",$to) . ")";
}return "<font color=\"$data{color}\"><b>$data{nick}$to:</b> $data{text}</font><br>\n";
}elsif ($data{command} eq 'msg')
{ConvertText($data{text},1);
if (ignored($data{from}) != 0)
{return "";
}if ($data{from} eq $user{name})
{$lastalive = time;
return "<font color=\"$data{color}\"><b>$data{nick} (" . sprintf($text{text_tagprivateto},$data{tonick}) . "):</b> $data{text}</font><br>\n";
}if ($data{to} eq $user{name})
{return "<font color=\"$data{color}\"><b>$data{nick} ($text{text_tagprivate}):</b> $data{text}</font><br>\n";
}}elsif ($data{command} eq 'me')
{if (ignored($data{name}) != 0)
{return "";
}if ($data{name} eq $user{name})
{$lastalive = time;
}ConvertText($data{text},0);
return "<font color=\"$data{color}\"><i>&lt;$data{nick} $data{text}&gt;</i></font><br>\n";
}elsif ($data{command} eq 'img')
{$data{url} =~ s/\"//g;
if ($data{tonick} eq "")
{return "<center><img src=\"$data{url}\" alt=\"" . getMessage('info_img',$data{nick}) . "\"></center><br>\n";
}else
{return "<center><img src=\"$data{url}\" alt=\"" . getMessage('info_img_private',$data{tonick},$data{nick}) . "\"></center><br>\n";
}}elsif ($data{command} eq 'broadcast')
{if ($data{nick} eq $user{nick})
{$lastalive = time;
}ConvertText($data{text},1);
return "<font color=\"$data{color}\"><b>$data{nick} ($text{text_tagtoall}):</b> $data{text}</font><br>\n";
}elsif ($data{command} eq 'admin')
{return "<b>$data{text}</b><br>\n";
}elsif ($data{command} eq 'away')
{if ($data{name} eq $user{name})
{$lastalive = time;
$user{away}=$data{away};
}my $text="<script>updateUserList();</script>\n";
if ($data{away} != 0)
{if ($data{text} ne "")
{$data{text} = ": $data{text}";
}return $text . "<b>$chatname:</b> " . getMessage('info_awayon',$data{nick}) . "$data{text}<br>\n";
}else
{return $text . "<b>$chatname:</b> " . getMessage('info_awayoff',$data{nick}) . "<br>\n";
}}elsif ($data{command} eq 'error')
{return "<b>$chatname:</b> $data{text}<br>\n";
}elsif ($data{command} eq 'color')
{$user{color}=$data{color};
return "<b>$chatname:</b> <font color=\"$data{color}\">" . getMessage('info_colorsuccessful',$data{nick}) . "</font><br>\n";
}elsif ($data{command} eq 'smileys')
{$user{smileys}=$data{smileys};
my $text = "<script>updateInput();</script>\n";
if ($user{smileys} != 0)
{return $text . "<b>$chatname:</b> " . getMessage('info_smileyssuccessful_on',$data{nick}) . "<br>\n";
}else
{return $text . "<b>$chatname:</b> " . getMessage('info_smileyssuccessful_off',$data{nick}) . "<br>\n";
}}elsif ($data{command} eq 'nick')
{if ($data{name} eq $user{name})
{$user{nick} = $data{tonick};
}return <<"EOT";
<script>updateUserList();</script>
<b>$chatname:</b> $data{text}<br>
EOT
}elsif ($data{command} eq 'room')
{my $text="";
if ($data{roomout} eq $user{room})
{$text .= "<script>updateUserList();</script>\n";
$text .= "<b>$chatname:</b> $data{textout}<br>\n";
}if ($data{roomin} eq $user{room})
{$text .= "<script>updateUserList();</script>\n";
$text .= "<b>$chatname:</b> $data{textin}<br>\n";
}if ($data{name} eq $user{name})
{$text .= "<script>updateRoomList();</script>\n";
$text .= "<br>" . MakeGreeting($room{outcome}) . "<br><br><br>\n";
$user{room}=$data{roomin};
%room = getroominfo($user{room});
$text .= MakeGreeting($room{income}) . "<br>\n";
$text .= getMessage('greeting_welcome',$room{name}) . "<br>\n";
$text .= getMessage('greeting_topic',$room{topic}) . "<br><br>\n";
}return $text;
}elsif ($data{command} eq 'ignore')
{push(@ignorelist,$data{name});
return "<b>$chatname:</b> " . getMessage('info_ignoresuccessful',$data{nick}) . "<br>\n";
}elsif ($data{command} eq 'unignore')
{for (my $i=0;$i<@ignorelist;$i++)
{if ($ignorelist[$i] eq $data{name})
{splice(@ignorelist,$i,1);
last;
}}return "<b>$chatname:</b> " . getMessage('info_unignoresuccessful',$data{nick}) . "<br>\n";
}elsif ($data{command} eq 'invite')
{my $text = "<script>updateRoomList();</script>\n";
if ($data{invite} == 0)
{$text .= "<b>$chatname:</b> " . getMessage('info_uninvited',$data{room}) . "<br>\n";
}else
{$text .= "<b>$chatname:</b> " . getMessage('info_invited',$data{room}) . "<br>\n";
}return $text;
}elsif ($data{command} eq 'group')
{my $text = "<script>updateUserList();</script>\n";
if ($data{name} eq $user{name})
{$user{group}=$data{group};
$text .= "<script>updateRoomList();</script>\n";
$text .= "<script>updateOptions();</script>\n";
}return $text;
}elsif ($data{command} eq 'roomchanged')
{return "<script>updateRoomList();</script>\n";
}elsif ($data{command} eq 'ownerchanged')
{return "<script>updateUserList();</script>\n";
}elsif ($data{command} eq 'alive')
{$lastalive = time;
return "";
}elsif ($data{command} eq 'quit')
{my $text = "";
if ($data{room} eq $user{room})
{$text .= "<b>$chatname:</b> $data{text}<br>\n";
}if ($data{name} eq $user{name} && ($data{id} eq "" || $data{id} eq $INFO{id}))
{writeonlineinfo(0,$user{name});
$text .= "<br>" . MakeGreeting($room{outcome}) . "<br><br><br>\n";
$end = 1;
}else
{$text .= "<script>updateUserList();</script>\n";
}return $text;
}elsif ($data{command} eq 'login')
{my $text = "";
if ($data{room} eq $user{room})
{$text .= "<b>$chatname:</b> $data{text}<br>\n";
}$text .= "<script>updateUserList();</script>\n";
return $text;
}return "";
}sub MakeGreeting
{my($string) = @_;
if ($string =~ /\S/)
{ToHTML($string);
if ($string !~ /[\.\!\?]$/)
{if ($string !~ /[\,]$/) { $string .= ","; }
$string .= " $user{nick}\n";
}return $string;
}else
{return "";
}}sub ConvertText
{if ($_[1] != 0)
{$_[0] =~ s~\*\*~&#42;~sg;
$_[0] =~ s~\_\_~&#95;~sg;
$_[0] =~ s~\*([^\*]+)\*~<i>$1</i>~sg;
$_[0] =~ s~\_([^\_]+)\_~<b>$1</b>~sg;
}$_[0] =~ s~(\w+://[^<>\*\s\n\"\]\[\(\),]+)~<a href="$1" target="_blank" id=\"stdlink\">$1</a>~isg;
$_[0] =~ s~\s(www\.[^<>\*\s\n\]\[\(\),]+)~ <a href="http://$1" target="_blank" id=\"stdlink\">http://$1</a>~isg;
$_[0] =~ s~^(www\.[^<>\*\s\n\]\[\(\),]+)~<a href="http://$1" target="_blank" id=\"stdlink\">http://$1</a>~isg;
$_[0] =~ s~([\w\.\-]+\@[\w\-]+\.[\w\.\-]+)~<a href=\"mailto:$1\" id=\"stdlink\"\>$1</a>~isg;
if ($user{smileys} != 0 && $enable_smileys != 0)
{my @smileys = split(/\|/,$smileys_defs);
for (my $i = 0; $i < @smileys; $i += 2)
{$smileys[$i] =~ s/^#//;
trim($smileys[$i+1]);
$smileys[$i+1] =~ s/(\s)+/ /g;
ToHTML($smileys[$i+1]);
my @patterns=split(/\s/,$smileys[$i+1]);
my($width,$height)=split(/,/,$image{$smileys[$i]});
my $tag="<img src=\"$imagesurl/$smileys[$i].gif\" width=\"$width\" height=\"$height\" border=0>";
foreach my $pattern (@patterns)
{$_[0] =~ s/^\Q$pattern\E/ $tag /g;
$_[0] =~ s/\s\Q$pattern\E/ $tag /g;
}}}}sub Logout
{@onlineinfo=getonlineinfo($user{name});
writeonlineinfo(0,$user{name});
TestRoomTemporary($user{room});
output("<script>doLogin();</script>\n");
printfooter("messages","{MESSAGES}");
msgctl($user{ipcid},$IPC_RMID,0);
if ($queue)
{my $filename=toFilename($user{name});
unlink("$memberdir/$filename.queue");
}exitprog();
}sub Login
{my $time=time;
open(FILE,"+<$vardir/logins.txt");
lock(FILE);
my @logins=<FILE>;
my($name,$password,$room) = ("","","");
my $found = 0;
seek(FILE,0,0);
foreach my $loginline (@logins)
{$loginline =~ s/[\n\r]//g;
my($lid,$lname,$lpassword,$lroom,$ltime)=split(/\|/,$loginline);
if ($time-$ltime<$max_login_time)
{print FILE "$loginline\n";
}if ($lid eq $INFO{id})
{($name,$password,$room)=($lname,$lpassword,$lroom);
$found = 1;
}}truncate(FILE,tell(FILE));
unlock(FILE);
close(FILE);
if ($found == 0)
{fatal_error('nologinrecord');
}if ($use_server_auth==0 && $password eq "")
{if ($allow_guestlogin==0)
{fatal_error('noguestlogin');
}if($name eq "")
{do
{$name=$group_names[1] . int(rand(1000));
} until (UserExists($name)==0 && addToMemberList($name,$name)==1);
}elsif (UserExists($name)!=0)
{fatal_error('usernameexists',$name);
}elsif (addToMemberList($name,$name)==0)
{fatal_error('nicknameexists',$name);
}$password=crypt(crypt($username,$pwseed),$pwseed);
writememberinfo(name => $name,
password => $password,
nick => $name,
group => -1,
smileys => 1,
emailpublic => 0);
}if($name eq "")
{fatal_error('nousernamegiven');
}%user = getmemberinfo($name);
if(!defined($user{name}))
{if (exists $COOKIE{$cookie_name})
{print "Set-Cookie: $cookie_name=; expires=Mon, 31-Jan-3000 12:00:00 GMT;\n";
}fatal_error('unknownusername',$name);
}if($use_server_auth==0 && $password ne $user{password})
{if (exists $COOKIE{$cookie_name})
{print "Set-Cookie: $cookie_name=; expires=Mon, 31-Jan-3000 12:00:00 GMT;\n";
}fatal_error('wrongpassword');
}if($user{group} < -1)
{ToHTML($webmaster_email);
fatal_error('usernamebanned!',"<a href=\"mailto:$webmaster_email\">$webmaster_email</a>");
}my %room=getroominfo($room);
if ($room{name} eq "" || RoomPermitted(%room)==0)
{$room = $defaultroom;
}$user{color} = makecolor($user{color});
if ($user{color} eq "")
{$user{color} = $defaultcolor;
}$user{ip} = $caller_ip;
$user{forwardedfor} = $caller_forwardedfor;
$user{host} = $caller_host;
$user{browser} = $ENV{HTTP_USER_AGENT};
$user{room} = $room;
$user{away} = 0;
$user{lastlogin} = $time;
$user{ignore} = "";
$user{pull} = ($INFO{pull}==0?0:1);
writememberinfo(%user);
}sub ConnectionBroken
{my $text=CommandToText(command => 'quit',
name => $user{name},
text => getMessage('out_chat',$user{nick},$chatname),
room => $user{room},
id => $INFO{id});
OutputCommand($text);
Logout();
}sub ignored
{my($name)=@_;
foreach my $entry (@ignorelist)
{if ($entry eq $name)
{return 1;
}}return 0;
}1;
