###############################################################################
# RoomList.pl                                                                 #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub RoomList
{my $roomdescr="";
my $roomnum=0;
open(ROOMS, "$roomdir/roomlist.txt");
readlock(ROOMS);
my @rooms=<ROOMS>;
unlock(ROOMS);
close(ROOMS);
foreach my $room (@rooms)
{$room =~ s/[\n\r]//g;
my %roominfo = getroominfo($room);
if (RoomPermitted(%roominfo)!=0)
{$roomnum++;
$roomdescr .= "<td align=center>";
if ($roominfo{name} eq $user{room})
{$roomdescr .= $room;
}else
{$roomdescr .= "<a href=\"javascript:sendText('/room $room')\">$room</a>";
}$roomdescr .= "</td>\n";
}}closedir(DIR);
my $rooms =<<"EOT";
<tr>
<th colspan="$roomnum">$text{rooms_title}</th>
</tr>
<tr id="table2">
$roomdescr
</tr>
EOT
printheader("rooms","",('{ROOMS}' => $rooms));
exitprog();
}sub ViewRooms
{open(FILE, "$vardir/online.txt");
readlock(FILE);
@entries = <FILE>;
unlock(FILE);
close(FILE);
my %users=();
foreach my $user (@entries)
{$user =~ s/[\n\r]//g;
my($name,$nick,$room,$ipcid) = split(/\|/,$user);
$users{$room} .= "|$nick $name";
}printheader("popup","{ROWS}",('{TITLE}' => $text{roomlist_title},
'{COMMENT}' => $text{roomlist_comment}));
output(<<"EOT");
<tr>
<th><b>$text{roomlist_name}</b></th>
<th><b>$text{roomlist_state}</b></th>
<th><b>$text{roomlist_topic}</b></th>
<th><b>$text{roomlist_owner}</b></th>
<th>&nbsp;</th>
</tr>
EOT
open(ROOMS, "$roomdir/roomlist.txt");
readlock(ROOMS);
my @rooms=<ROOMS>;
unlock(ROOMS);
close(ROOMS);
foreach my $room (@rooms)
{$room =~ s/[\n\r]//g;
my %roominfo = getroominfo($room);
if (RoomPermitted(%roominfo)!=0)
{my $status=$text{roomlist_state_public};
if ($roominfo{closed} != 0)
{$status=$text{roomlist_state_private};
}if ($roominfo{permanent} == 0)
{$status .= ", $text{roomlist_state_temporary}";
}my $options = "";
my %userinfo = getmemberinfo($roominfo{owner});
if ((hasPermission('rooms_modify') && $user{group} > $userinfo{group}) || $user{name} eq $userinfo{name})
{$options = "<a href=\"$cgi&action=modifyroom&room=" . escape($room) . "\">$text{roomlist_room_modify}</a>";
}my $list = "";
foreach my $entry (sort {lcase($a) cmp lcase($b)} split(/\|/,$users{$room}))
{if ($entry ne "")
{my($nick,$name)=split(/ /,$entry);
$list .= " <a href=\"$cgi&action=viewprofile&username=" . toFilename($name) . "\">$nick</a>";
}}if ($list ne "") {
$list = "<tr id=\"table2\"><td colspan=4>$text{roomlist_room_users}:$list</td></tr>";
}my $rowspan = ($list eq ""?"":"rowspan=2");
output(<<"EOT");
<tr id="table2">
<td $rowspan>$room</td>
<td>$status</td>
<td>$roominfo{topic}&nbsp;</td>
<td>$userinfo{nick}&nbsp;</td>
<td>$options&nbsp;</td>
</tr>
$list
EOT
}}closedir(DIR);
if (hasPermission('rooms_create'))
{output(<<"EOT");
<tr id="table2">
<td colspan=6 align=center><a href="$cgi&action=modifyroom">$text{roomlist_createnew}</a></td>
</tr>
EOT
}printfooter("popup","{ROWS}",('{TITLE}' => $text{roomlist_title},
'{COMMENT}' => $text{roomlist_comment}));
exitprog();
}sub ModifyRoom
{my %roominfo = ();
my %userinfo = ();
my $title=$text{createroom_title};
my $delete="";
my $room = "<input type=text name=room size=30 maxlength=50 style=\"width=100%\">";
my $modify = 0;
if ($INFO{room} ne "")
{%roominfo=getroominfo($INFO{room});
if ($roominfo{name} eq "")
{fatal_error('unknownroom',$INFO{room});
}%userinfo = getmemberinfo($roominfo{owner});
if ((!hasPermission('rooms_modify') || $user{group} <= $userinfo{group}) && $userinfo{name} ne $user{name})
{fatal_error('roomlist_nopermission');
}$title=$text{modifyroom_title};
if ($roominfo{name} ne $defaultroom)
{$delete="<input type=submit onClick=\"form.action.value='deleteroom'\" value=\"$text{deleteroom_submit}\">";
}$room = "$roominfo{name}<input type=hidden name=room value=\"$roominfo{name}\">";
$modify = 1;
}elsif (!hasPermission('rooms_create'))
{fatal_error('nopermission');
}if ($userinfo{nick} eq "") {
$userinfo{nick} = $user{nick};
}my $owner = "<input type=text name=owner value=\"$userinfo{nick}\" size=30 maxlength=50 style=\"width=100%\">";
if (!hasPermission('rooms_changeowner'))
{$owner = "$user{nick}&nbsp;";
}my $closed;
if (eqi($roominfo{name},$defaultroom))
{$closed = $text{roomlist_state_public};
}else
{$closed = "<select name=closed>\n";
if ($roominfo{closed}==0)
{$closed .= "<option value=0 selected>$text{roomlist_state_public}\n<option value=1>$text{roomlist_state_private}\n";
}else
{$closed .= "<option value=0>$text{roomlist_state_public}\n<option value=1 selected>$text{roomlist_state_private}\n";
}$closed .= "</select>";
if (!hasPermission('rooms_createprivate'))
{$closed = ($roominfo{closed}==0?$text{roomlist_state_public}:$text{roomlist_state_private});
}}$roominfo{permanent} += 0;
my $permanent="<select name=permanent>\n";
if ($roominfo{permanent}==0)
{$permanent .= "<option value=0 selected>$text{roomlist_state_temporary}\n<option value=1>$text{roomlist_state_permanent}\n";
}else
{$permanent .= "<option value=0>$text{roomlist_state_temporary}\n<option value=1 selected>$text{roomlist_state_permanent}\n";
}$permanent .= "</select>";
$roominfo{permanent}=1 if (eqi($roominfo{name},$defaultroom));
if (!hasPermission('rooms_createpermanent') || eqi($roominfo{name},$defaultroom))
{$permanent = ($roominfo{permanent}==0?$text{roomlist_state_temporary}:$text{roomlist_state_permanent});
}if ($userinfo{nick} eq "")
{$userinfo{nick}=$user{nick};
}printheader("popup","{ROWS}",('{TITLE}' => $title,
'{COMMENT}' => $text{modifyroom_comment}));
output(<<"EOT");
<tr><th>$title</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST action="$cgi">
<input type=hidden name=action value="modifyroom2">
<input type=hidden name=modify value=$modify>
<tr>
<td><b>$text{roomlist_name}:</b></td>
<td width=100%>$room</td>
</tr>
<tr>
<td><b>$text{roomlist_topic}:</b></td>
<td><input type=text name=topic value="$roominfo{topic}" size=30 maxlength=255 style="width=100%"></td>
</tr>
<tr>
<td><b>$text{roomlist_greetingmessage}:</b></td>
<td><input type=text name=income value="$roominfo{income}" size=30 maxlength=255 style="width=100%"></td>
</tr>
<tr>
<td><b>$text{roomlist_goodbyemessage}:</b></td>
<td><input type=text name=outcome value="$roominfo{outcome}" size=30 maxlength=255 style="width=100%"></td>
</tr>
<tr>
<td><b>$text{roomlist_owner}:</b></td>
<td>$owner</td>
</tr>
<tr>
<td><b>$text{roomlist_accessibility}:</b></td>
<td>$closed</td>
</tr>
<tr>
<td><b>$text{roomlist_permanence}:</b></td>
<td>$permanent</td>
</tr>
<tr>
<td colspan=2 align=center>
<input type=submit onClick="form.action.value='modifyroom2'" value="$text{modifyroom_submit}">
$delete
</td>
</tr>
</table>
</td></tr>
</form>
</table></td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => $title,
'{COMMENT}' => $text{modifyroom_comment}));
exitprog();
}sub ModifyRoom2
{CheckName($FORM{room});
fatal_error('noroomnamegiven') if($FORM{room} eq "");
my %roominfo=getroominfo($FORM{room});
if ($FORM{modify}==0)
{if (!hasPermission('rooms_create'))
{fatal_error('nopermission');
}if ($roominfo{name} ne "")
{fatal_error('roomnameexists',$FORM{room});
}}else
{if ($roominfo{name} eq "")
{fatal_error('unknownroom',$FORM{room});
}my %userinfo = getmemberinfo($roominfo{owner});
if ((!hasPermission('rooms_modify') || $user{group} <= $userinfo{group}) && $userinfo{name} ne $user{name})
{fatal_error('roomlist_nopermission');
}}my $owner="";
if (!hasPermission('rooms_changeowner'))
{$owner = $user{name};
}elsif ($FORM{owner} ne "")
{open(FILE, "$memberdir/memberlist.txt");
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my @userdata = split(/\|/, $curentry);
if(eqi($userdata[0],$FORM{owner}))
{$owner=$userdata[1];
last;
}elsif(eqi(substr($userdata[0],0,length($FORM{owner})),$FORM{owner}))
{$owner = ($owner eq ""?$userdata[1]:"|");
}}if ($owner eq "")
{fatal_error('unknownowner',$FORM{owner});
}if ($owner eq "|")
{fatal_error('ambiguousowner');
}}my %oldroominfo=%roominfo;
$roominfo{name}=$FORM{room};
$roominfo{owner}=$owner;
$roominfo{topic}=$FORM{topic};
$roominfo{income}=$FORM{income};
$roominfo{outcome}=$FORM{outcome};
if (!hasPermission('rooms_createprivate'))
{$roominfo{closed} = $oldroominfo{closed};
}else
{$roominfo{closed} = ($FORM{closed}==0 || eqi($roominfo{name},$defaultroom)?0:1);
}if (!hasPermission('rooms_createpermanent'))
{$roominfo{permanent} = $oldroominfo{permanent};
}else
{$roominfo{permanent} = ($FORM{permanent}==0 && $roominfo{name} ne $defaultroom?0:1);
}writeroominfo(%roominfo);
if ($FORM{modify}==0 || $roominfo{closed}!=$oldroominfo{closed})
{my $text=CommandToText(command => 'roomchanged',
room => $roominfo{name});
OutputCommand($text);
}if ($FORM{modify}!=0 && $roominfo{owner} ne $oldroominfo{owner})
{my $text=CommandToText(command => 'ownerchanged',
room => $roominfo{name});
OutputCommand($text,$roominfo{owner},$roominfo{name});
}if ($roominfo{permanent}==0 && $user{room} ne $roominfo{name})
{($user{name}, $user{nick}, $user{room}, $user{ipcid}) = getonlineinfo($user{name});
my $oldroom = $user{room};
$user{room} = $roominfo{name};
writeonlineinfo(0,$user{name},$user{nick},$user{room},$user{ipcid},$INFO{id});
writememberinfo(%user);
TestRoomTemporary($oldroom);
my $text=CommandToText(command => 'room',
name => $user{name},
roomout => $oldroom,
textout => getMessage('out_room',$user{nick},"$oldroom"),
roomin => $user{room},
textin => getMessage('in_room',$user{nick},"$user{room}"));
OutputCommand($text);
}if ($oldroominfo{name} ne $roominfo{name})
{addToRoomList($roominfo{name},$oldroominfo{name});
}print "Location: $cgi&action=viewrooms\n\n";
exitprog();
}sub DeleteRoom
{CheckName($FORM{room});
fatal_error('noroomnamegiven') if($FORM{room} eq "");
my %roominfo=getroominfo($FORM{room});
if ($roominfo{name} eq "")
{fatal_error('unknownroom',$FORM{room});
}my %userinfo = getmemberinfo($roominfo{owner});
if ((!hasPermission('rooms_modify') || $user{group} <= $userinfo{group}) && $userinfo{name} ne $user{name})
{fatal_error('roomlist_nopermission');
}open(FILE, "$vardir/online.txt");
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my ($name, $nick, $room, $ipcid, $id) = split(/\|/, $curentry);
if($room eq $roominfo{name})
{my %userinfo = getmemberinfo($name);
my $oldroom = $room;
$room = $defaultroom;
$userinfo{room} = $defaultroom;
writeonlineinfo(0,$name,$nick,$room,$ipcid,$id);
writememberinfo(%userinfo);
my $text=CommandToText(command => 'room',
name => $name,
roomout => $oldroom,
textout => getMessage('out_room',$nick,"$oldroom"),
roomin => $room,
textin => getMessage('in_room',$nick,"$room"));
OutputCommand($text);
}}unlink("$roomdir/" . toFilename($roominfo{name}) . ".dat");
addToRoomList("",$roominfo{name});
my $text=CommandToText(command => 'roomchanged',
room => $roominfo{name});
OutputCommand($text);
print "Location: $cgi&action=viewrooms\n\n";
exitprog();
}1;
