###############################################################################
# Subs.pl                                                                     #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
$traffic = 0;
sub readform
{my $input="";
if (exists($ENV{'CONTENT_LENGTH'})) {
read(STDIN, $input, $ENV{'CONTENT_LENGTH'});
}foreach my $pair (split(/&/, $input))
{my($name, $value) = split(/=/, $pair);
$name =~ tr/+/ /;
$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
}foreach my $pair (split(/&/, $ENV{QUERY_STRING}))
{my($name, $value) = split(/=/, $pair);
$name =~ tr/+/ /;
$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$INFO{$name} = $value;
}$action = $INFO{'action'};
if (defined($FORM{action}))
{$action = $FORM{action};
}}sub readlock
{my($file)=@_;
if($use_flock)
{flock($file, $LOCK_SH);
}}sub lock
{my($file)=@_;
if($use_flock)
{flock($file, $LOCK_EX);
}}sub unlock
{my($file)=@_;
if($use_flock)
{flock($file, $LOCK_UN);
}}sub getonlineinfo
{my($name) = @_;
open(FILE, "$vardir/online.txt");
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my @userdata = split(/\|/, $curentry);
if($userdata[0] eq $name)
{return @userdata;
}}return ();
}sub writeonlineinfo
{my $add = shift(@_);
my @writedata = @_;
open(FILE, "+<$vardir/online.txt");
lock(FILE);
my @entries = <FILE>;
seek(FILE,0,0);
my $found = 0;
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my @userdata = split(/\|/, $curentry);
if($writedata[0] ne $userdata[0])
{print FILE "$curentry\n";
}elsif (defined($writedata[1]))
{print FILE join('|',@writedata) . "\n";
$found = 1;
}}if (defined($writedata[1]) && $found==0 && $add!=0)
{print FILE join('|',@writedata) . "\n";
}truncate(FILE, tell(FILE));
unlock(FILE);
close(FILE);
if (!defined($writedata[1]))
{my %userinfo=getmemberinfo($writedata[0]);
if ($userinfo{name} ne "" && $userinfo{group}==-1)
{addToMemberList($userinfo{name});
my $filename=toFilename($userinfo{name});
unlink("$memberdir/$filename.dat");
}}}sub getmemberinfo
{my($name) = @_;
my $filename=toFilename($name);
open(FILE, "$memberdir/$filename.dat") || return;
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
my %user = (name => lowercase($name));
$i = 0;
foreach my $param (split(/\|/, $memberinfo))
{$entries[$i] =~ s/[\n\r]//g;
$user{$param} = $entries[$i];
$i++;
}return %user;
}sub writememberinfo
{my(%user) = @_;
my $filename=toFilename($user{name});
open(FILE, ">$memberdir/$filename.dat") || return;
lock(FILE);
foreach my $param (split(/\|/, $memberinfo))
{$user{$param}="" if (!exists($user{$param}));
print FILE "$user{$param}\n";
}unlock(FILE);
close(FILE);
}sub getroominfo
{my($name) = @_;
open(FILE, "$roomdir/" . toFilename($name) . ".dat") || return;
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
my %room = (name => $name);
$i = 0;
foreach my $param (split(/\|/, $roominfo))
{$entries[$i] =~ s/[\n\r]//g;
$room{$param} = $entries[$i];
$i++;
}return %room;
}sub writeroominfo
{my(%room) = @_;
open(FILE, ">$roomdir/" . toFilename($room{name}) . ".dat") || return;
lock(FILE);
foreach my $param (split(/\|/, $roominfo))
{$room{$param}="" if (!exists($room{$param}));
print FILE "$room{$param}\n";
}unlock(FILE);
close(FILE);
}sub printheader
{my($template, $endtag, %tags) = @_;
$endtag="" if (!defined($endtag));
print "Content-type: text/html\n";
print "Pragma: no-cache\n";
print "Expires: now\n\n";
open(FILE, "$templdir/$template.html");
readlock(FILE);
my @lines = <FILE>;
unlock(FILE);
close(FILE);
foreach my $line (@lines)
{$line =~ s/[\n\r]//g;
if ($endtag ne "" && $line eq $endtag)
{last;
}if (exists($tags{$line}))
{output("$tags{$line}\n");
}else
{$line =~ s/\{CHATNAME\}/$chatname/g;
$line =~ s/\{CGI\}/$cgi/g;
$line =~ s/\{HTMLURL\}/$htmlurl\//g;
output("$line\n");
}}}sub printfooter
{my($template, $endtag, %tags) = @_;
$endtag="" if (!defined($endtag));
open(FILE, "$templdir/$template.html");
readlock(FILE);
my @lines = <FILE>;
unlock(FILE);
close(FILE);
my $doprint = 0;
foreach my $line (@lines)
{$line =~ s/[\n\r]//g;
if ($doprint == 1)
{if (exists($tags{$line}))
{output("$tags{$line}\n");
}else
{$line =~ s/\{CHATNAME\}/$chatname/g;
$line =~ s/\{CGI\}/$cgi/g;
$line =~ s/\{HTMLURL\}/$htmlurl\//g;
output("$line\n");
}}if ($endtag ne "" && $line eq $endtag)
{$doprint = 1;
}}}sub fatal_error
{my $error = shift(@_);
printheader("error", "", ("{ERROR}" => getMessage('error_' . $error,@_)));
exitprog();
}sub lcase
{my($ret)=@_;
$ret = lc($ret);
$ret =~ s///;
$ret =~ s///;
$ret =~ s///;
return $ret;
}sub lowercase
{$_[0] = lcase($_[0]);
}sub makecolor
{my($c) = @_;
lowercase($c);
$c =~ s/^#//;
if (exists($color{$c}))
{return $color{$c};
}elsif ($c =~ /^[0-9a-f]{1,6}$/)
{return "#$c";
}else
{return "";
}}sub TextToCommand
{my($string) = @_;
$string =~ s/[\n\r]//g;
my @entries = split(/\|/, $string);
if (!exists($params{$entries[0]}))
{return (command => "");
}my %command = (command => $entries[0]);
my $i = 1;
foreach my $param (split(/\|/,$params{$entries[0]}))
{$command{$param} = $entries[$i];
$i++;
}return %command;
}sub CommandToText
{my %command = @_;
if (!exists($params{$command{command}}))
{return "";
}my $string = "$command{'command'}";
foreach my $param (split(/\|/,$params{$command{command}}))
{$string .= "|" . $command{$param};
}return $string;
}sub ErrorText
{my $error=shift(@_);
return CommandToText(command => 'error',
text => getMessage('error_' . $error,@_));
}sub InfoText
{my $msg=shift(@_);
return CommandToText(command => 'error',
text => getMessage('info_' . $msg,@_));
}sub ToHTML
{$_[0] =~ s/\&/\&amp\&/g;
$_[0] =~ s/;/\&#59;/g;
$_[0] =~ s/\&amp\&/\&amp;/g;
$_[0] =~ s/"/\&quot;/g;
$_[0] =~ s/  / \&nbsp;/g;
$_[0] =~ s/</\&lt;/g;
$_[0] =~ s/>/\&gt;/g;
$_[0] =~ s/\|/\&#124;/g;
$_[0] =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
$_[0] =~ s/\n/<br>/g;
return $_[0];
}sub completeName
{my ($nick,$room) = @_;
$room="" if (!defined($room));
open(FILE, "$vardir/online.txt");
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
my @ret=();
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my @userdata = split(/\|/, $curentry);
if(eqi($userdata[1],$nick) && ($room eq "" || $room eq $userdata[2]))
{return ($userdata[0],$userdata[1]);
}elsif(eqi(substr($userdata[1],0,length($nick)),$nick) && ($room eq "" || $room eq $userdata[2]))
{push(@ret,$userdata[0]);
push(@ret,$userdata[1]);
}}return @ret;
}sub completeMember
{my($nick) = @_;
open(FILE, "$memberdir/memberlist.txt");
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
my @ret=();
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my @userdata = split(/\|/, $curentry);
if($userdata[0] eq $nick)
{return ($userdata[1],$userdata[0]);
}elsif($userdata[0] =~ /^\Q$nick\E/i)
{push(@ret,$userdata[1]);
push(@ret,$userdata[0]);
}}return @ret;
}sub addToMemberList
{my($name,$nick)=@_;
lowercase($name);
my $lnick = $nick;
lowercase($lnick);
open(FILE, "+<$memberdir/memberlist.txt");
lock(FILE);
@members=<FILE>;
my $written=1;
if ($nick ne "")
{foreach my $member (@members)
{$member =~ s/[\n\r]//g;
my ($membernick,$membername)=split(/\|/,$member);
lowercase($membernick);
if ($membername ne $name && $membernick eq $lnick)
{return 0;
}}$written=0;
}seek(FILE,0,0);
foreach my $member (@members)
{$member =~ s/[\n\r]//g;
my ($membernick,$membername)=split(/\|/,$member);
lowercase($membernick);
if ($written == 0 && $membernick gt $lnick)
{print FILE "$nick|$name\n";
$written = 1;
}if ($membername ne $name)
{print FILE "$member\n";
}}if ($written == 0)
{print FILE "$nick|$name\n";
}truncate(FILE,tell(FILE));
unlock(FILE);
close(FILE);
}sub OutputCommand
{my($command, $touser, $toroom) = @_;
$touser="" if (!defined($touser));
$toroom="" if (!defined($toroom));
open(FILE, "$vardir/online.txt");
readlock(FILE);
foreach my $entry (<FILE>)
{$entry =~ s/[\n\r]//g;
my($name,$nick,$room,$ipcid) = split(/\|/,$entry);
if (($touser ne "" && $touser eq $name) || ($toroom ne "" && $toroom eq $room) || ($touser eq "" && $toroom eq ""))
{msgsnd($ipcid,pack("La*",1,$command),$IPC_NOWAIT);
}}unlock(FILE);
close(FILE);
if ($log_clean_rate > 0 && ($toroom ne "" || $touser eq ""))
{WriteLog($command,$toroom);
}}sub WriteLog
{my($command,$toroom) = @_;
$toroom="" if (!defined($toroom));
my $time=time();
open(LOG, ">>$vardir/log.txt");
lock(LOG);
print LOG "$time|$toroom|$command\n";
unlock(LOG);
close(LOG);
my $do_clean_log = 0;
open(FILE, "+<$vardir/last_cleaned.txt");
lock(FILE);
my $last_cleaned=<FILE>;
if ($time-$last_cleaned > $log_clean_rate)
{$do_clean_log = 1;
seek(FILE,0,0);
print FILE $time;
truncate(FILE, tell(FILE));
}unlock(FILE);
close(FILE);
if ($do_clean_log == 1)
{open(LOG, "+<$vardir/log.txt");
lock(LOG);
@entries = <LOG>;
seek(LOG,0,0);
foreach $entry (@entries)
{if ($time-$entry <= $log_length)
{print LOG $entry;
}}truncate(LOG, tell(LOG));
unlock(LOG);
close(LOG);
}}sub toDate
{my($time) = @_;
my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time+$time_distance*3600);
$mon++;
$hour = "0$hour" if ($hour < 10);
$min = "0$min" if ($min < 10);
$sec = "0$sec" if ($sec < 10);
$year = 1900 + $year;
$mon = "0$mon" if ($mon < 10);
$mday = "0$mday" if ($mday < 10);
return "$mday.$mon.$year $hour\:$min\:$sec";
}sub output
{my($line)=@_;
if ($queue == 0)
{my $ret=print($line);
$traffic += length($line);
return $ret;
}else
{$line =~ s/[\r\t]//g;
my $filename=toFilename($user{name});
open(FILE,">>$memberdir/$filename.queue");
lock(FILE);
print FILE $line;
unlock(FILE);
close(FILE);
}}sub exitprog
{addToTraffic($traffic);
exit;
}sub addToTraffic
{if ($enable_traffic_stat == 0) { return; }
my($bytes) = @_;
my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time+$time_distance*3600);
$mon++;
$year = 1900 + $year;
$mon = "0$mon" if ($mon < 10);
$mday = "0$mday" if ($mday < 10);
my $date = "$mday.$mon.$year";
my $found = 0;
open(FILE, "+<$vardir/traffic.txt");
lock(FILE);
@entries = <FILE>;
seek(FILE,0,0);
foreach $entry (@entries)
{$entry =~ s/[\n\r]//g;
my($mdate,$traffic) = split(/\|/,$entry);
if ($date eq $mdate)
{$found = 1;
$traffic += $bytes;
}print FILE "$mdate|$traffic\n";
}if ($found == 0)
{print FILE "$date|$bytes\n";
}truncate(FILE, tell(FILE));
unlock(FILE);
close(FILE);
}sub TestRoomTemporary
{my ($room)=@_;
my %roominfo=getroominfo($room);
if ($roominfo{name} ne "" && $roominfo{name} ne $defaultroom && $roominfo{permanent}==0)
{open(FILE, "$vardir/online.txt");
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
foreach my $curentry (@entries)
{$curentry =~ s/[\n\r]//g;
my @userdata = split(/\|/, $curentry);
if($userdata[2] eq $roominfo{name})
{return;
}}unlink("$roomdir/" . toFilename($roominfo{name}) . ".dat");
addToRoomList("",$roominfo{name});
my $text=CommandToText(command => 'roomchanged',
room => $roominfo{name});
OutputCommand($text);
}}sub RoomPermitted
{my(%room) = @_;
return 0 if (!defined($room{name}));
return 1 if ($room{closed}==0 || hasPermission('privaterooms') || $user{name} eq $room{owner});
foreach my $entry (split(/\s/,$room{invited}))
{if ($entry eq $user{name})
{return 1;
}}return 0;
}sub trim
{$_[0] =~ s/^(\s|&nbsp;)*//g;
$_[0] =~ s/(\s|&nbsp;)*$//g;
return $_[0];
}sub getMessage
{my $name=shift(@_);
$allowhtml=0;
if ($name =~ /\!$/)
{$name =~ s/\!$//;
$allowhtml=1;
}my @messages=split(/\n/,$message{$name});
my $msg=$messages[rand @messages];
if ($allowhtml!=0)
{ToHTML($msg);
$msg=sprintf($msg,@_);
}else
{$msg=sprintf($msg,@_);
ToHTML($msg);
}return $msg;
}sub writeString
{my ($name) = @_;
my $string;
eval "\$string=\$$name;";
$string =~ s/\r//g;
$string =~ s/\\/\\\\/g;
$string =~ s/\'/\\\'/g;
print FILE "\$$name='$string';\n";
}sub writeInt
{my ($name) = @_;
my $int;
eval "\$int=\$$name;";
$int+=0;
print FILE "\$$name=$int;\n";
}sub writeList
{my ($name) = @_;
my @list;
eval "\@list=\@$name;";
my $text = "\@$name = (";
foreach my $entry (@list)
{$entry =~ s/\r//g;
$entry =~ s/\\/\\\\/g;
$entry =~ s/\'/\\\'/g;
$text .= "'$entry',";
}$text =~ s/\,$//g;
print FILE "$text);\n";
}sub writeHash
{my ($name) = @_;
my %hash;
eval "%hash=%$name;";
foreach my $key (sort keys %hash)
{my $text=$hash{$key};
$text =~ s/\r//g;
$text =~ s/\\/\\\\/g;
$text =~ s/\'/\\\'/g;
print FILE "\$$name\{'$key'\}='$text';\n";
}}sub writeLanguageFile
{open(FILE,">$language.lng") || fatal_error('couldnotopen',"$language.lng");
lock(FILE);
writeList("group_names");
writeList("group_tags");
writeList("months_names");
writeHash("message");
writeHash("text");
print FILE "1;\n";
unlock(FILE);
close(FILE);
}sub toFilename
{my($username)=@_;
lowercase($username);
my $bits = unpack("b*", $username);
my $ret="_";
for (my $i=0;$i<length($bits);$i+=5)
{my $part=substr($bits,$i,5);
$n=ord(pack("b8",$part));
if ($n<26)
{$n+=ord('a');
}else
{$n+=ord('0')-26;
}$ret .= chr($n);
}return $ret;
}sub fromFilename
{my($filename)=@_;
lowercase($filename);
return "" if ($filename !~ /^_/);
$filename = substr($filename,1);
my $bits="";
for (my $i=0;$i<length($filename);$i++)
{$n=ord(substr($filename,$i,1));
if ($n>=ord('a'))
{$n-=ord('a');
}else
{$n-=ord('0')-26;
}$bits .= unpack("b5",chr($n));
}my $ret="";
for (my $i=0;$i<length($bits);$i+=8)
{my $part=substr($bits,$i,8);
if (length($part)==8)
{$ret .= pack("b8",$part);
}}return $ret;
}sub UserExists
{my($username)=@_;
$username=toFilename($username);
if (-e "$memberdir/$username.dat")
{return 1;
}else
{return 0;
}}sub CheckName
{$_[0] =~ s/[=;\<\>\:\@\|\'\"\n\r]//g;
trim($_[0]);
$_[0] =~ s/\s/_/g;
}sub CheckPassword
{$_[0] =~ s/[\<\>\:\@\|\'\"\n\r]//g;
trim($_[0]);
}sub addToRoomList
{my($room,$old)=@_;
my $lroom=$room;
lowercase($lroom);
lowercase($old);
open(FILE, "+<$roomdir/roomlist.txt");
lock(FILE);
@rooms=<FILE>;
my $written=0;
seek(FILE,0,0);
foreach my $entry (@rooms)
{$entry =~ s/[\n\r]//g;
$lentry=$entry;
lowercase($lentry);
if ($written == 0 && $room ne "" && $lentry gt $lroom)
{print FILE "$room\n";
$written = 1;
}if ($lentry ne $old)
{print FILE "$entry\n";
}}if ($written == 0 && $room ne "")
{print FILE "$room\n";
}truncate(FILE,tell(FILE));
unlock(FILE);
close(FILE);
}sub eqi
{my($a,$b)=@_;
lowercase($a);
lowercase($b);
return ($a eq $b);
}sub escape
{my($string)=@_;
$string =~ s/(.)/"%".unpack("H2",$1)/eg;
return $string;
}sub getBirthdateInput
{my $ret=<<"EOT";
<input type=text name=day size=4 maxlength=2 value="$text{profile_birthdate_day}">
<select name=month>
<option value=0>$text{profile_birthdate_month}
EOT
for(my $i=1;$i<=@months_names;$i++)
{$ret .= "<option value=$i>$months_names[$i-1]";
}$ret .=<<"EOT";
</select>
<input type=text name=year size=4 maxlength=4 value="$text{profile_birthdate_year}">
EOT
return $ret;
}sub getDescription
{my($name)=@_;
if (exists($descr{$name}))
{ToHTML($descr{$name});
my($width,$height)=split(/,/,$image{question});
$descr{$name} =~ s/\'/\\\'/g;
return " <a href=\"javascript:alert('$descr{$name}')\"><img src=\"$imagesurl/question.gif\" width=\"$width\" height=\"$height\" border=0\"></a>";
}return "";
}sub writeSettingsFile
{open(FILE,">Settings.dat") || fatal_error('couldnotopen',"Settings.dat");
lock(FILE);
foreach my $var (split(/\|/,$settingsfile))
{if ($var =~ /^\$/)
{$var =~ s/^\$//;
writeString($var);
}elsif ($var =~ /^\#/)
{$var =~ s/^\#//;
writeInt($var);
}elsif ($var =~ /^\@/)
{$var =~ s/^\@//;
writeList($var);
}elsif ($var =~ /^\%/)
{$var =~ s/^\%//;
writeHash($var);
}}print FILE "1;\n";
unlock(FILE);
close(FILE);
}sub hasPermission
{my($name)=@_;
if (exists($permission{$name}) && $user{group}>=$permission{$name})
{return 1;
}else
{return 0;
}}1;
