###############################################################################
# UserList.pl                                                                 #
###############################################################################
# GTChat (http://www.gtchat.de)                                               #
# GTChat 0.92 Copyright (c) 2001 by Wladimir Palant                           #
# Changes on this file are not permitted!                                     #
###############################################################################
sub UserList
{my %roominfo=getroominfo($user{room});
if ($roominfo{name} eq "")
{ToHTML($user{room});
fatal_error('unknownroom',$user{room});
}open(FILE, "$vardir/online.txt");
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
my @users;
foreach my $entry (@entries)
{$entry =~ s/[\n\r]//g;
my($name,$nick,$room,$ipcid) = split(/\|/, $entry);
if ($room eq $roominfo{name})
{my %info = getmemberinfo($name);
if ($info{name} ne "")
{my $text="$info{nick} $info{name} $info{away} $info{group} " . ($roominfo{owner} eq $info{name}?"1":"0");
push(@users,$text);
}}}my $userlist="";
@users=sort {lcase($a) cmp lcase($b)} @users;
foreach my $entry (@users)
{my($nick,$name,$away,$group,$owner) = split(/ /,$entry);
$name=toFilename($name);
$userlist .= "<tr><td nowrap><a href=\"javascript:viewProfile('$name')\">";
if ($away == 0)
{$userlist .= "<b>$nick</b>";
}else
{$userlist .= "($nick)";
}$userlist .= "</a>";
if ($group<=0 && $owner != 0)
{$userlist .= " ($text{users_tagowner})";
}elsif ($group_tags[$group+2] ne "")
{$userlist .= " ($group_tags[$group+2])";
}$userlist .= "</td></tr>\n";
}my $ntotal=@entries;
my $nusers=@users;
printheader("users","",('{ROOM}' => sprintf($text{users_title},$user{room},$nusers,$ntotal),
'{USERS}' => $userlist));
exitprog();
}sub AllUsers
{open(FILE, "$memberdir/memberlist.txt");
readlock(FILE);
my @entries = <FILE>;
unlock(FILE);
close(FILE);
my $userlist=<<"EOT";
<tr><th>$text{userlist_title}</th></tr>
<tr id="table2"><td><table width=100%>
EOT
foreach my $entry (@entries)
{$entry =~ s/[\n\r]//g;
my($nick,$name) = split(/\|/, $entry);
if ($user{name} eq "")
{$userlist .= "<tr><td>$nick</td></tr>\n";
}else
{$userlist .= "<tr><td><a href=\"$cgi&action=viewprofile&username=" . toFilename($name) . "\">$nick</a></td></tr>\n";
}}$userlist .= "</table></td></tr>\n";
printheader("popup","",('{TITLE}' => $text{userlist_title},
'{ROWS}' => $userlist,
'{COMMENT}' => $text{userlist_comment}));
exitprog();
}sub SearchUser
{CheckName($INFO{text});
my $selected0 = ($INFO{position}==0?"selected":"");
my $selected1 = ($INFO{position}==1?"selected":"");
my $selected2 = ($INFO{position}==2?"selected":"");
printheader("popup","{ROWS}",('{TITLE}' => $text{usersearch_title},
'{COMMENT}' => $text{usersearch_comment}));
output(<<"EOT");
<tr><th>$text{usersearch_title}</th></tr>
<tr id="table2"><td><table width=100%>
<form method=POST action="$cgi&action=searchuser2">
<tr>
<td><b>$text{usersearch_text}:</b></td>
<td width="100%"><input type=text name=text size=10 style="width:100%" maxlength=50 value="$INFO{text}"></td>
</tr>
<tr>
<td><b>$text{usersearch_position}:</b></td>
<td>
<select name=position style="width:100%">
<option value=0 $selected0>$text{usersearch_position_somewhere}
<option value=1 $selected1>$text{usersearch_position_beginning}
<option value=2 $selected2>$text{usersearch_position_end}
</select>
</td>
</tr>
<tr>
<td colspan=2 align=center>
<input type=submit value="$text{usersearch_submit}">
</td>
</tr>
<tr>
<td colspan=2 align=center>
<a href="$cgi&action=allusers">$text{usersearch_showall}</a>
</td>
</tr>
</table></td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => $text{usersearch_title},
'{COMMENT}' => $text{usersearch_comment}));
exitprog();
}sub SearchUser2
{CheckName($FORM{text});
$FORM{position}+=0;
fatal_error('search_nothingtodo') if($FORM{text} eq "");
open(USERS,"$memberdir/memberlist.txt");
readlock(USERS);
my @users = <USERS>;
unlock(USERS);
close(USERS);
printheader("popup","{ROWS}",('{TITLE}' => $text{searchresults_title},
'{COMMENT}' => $text{searchresults_comment}));
output(<<"EOT");
<tr><th>$text{searchresults_title}</th></tr>
<tr id="table2"><td><table width=100%>
EOT
my $found=0;
foreach my $entry (@users)
{$entry =~ s/[\n\r]//;
my ($nick,$name) = split(/\|/,$entry);
if (($FORM{position}==0 && $nick =~ /\Q$FORM{text}\E/i)
|| ($FORM{position}==1 && $nick =~ /^\Q$FORM{text}\E/i)
|| ($FORM{position}==2 && $nick =~ /\Q$FORM{text}\E$/i))
{output("<tr><td><a href=\"$cgi&action=viewprofile&username=" . toFilename($name) . "\">$nick</a></td></tr>\n");
$found=1;
}}if ($found==0)
{output("<tr><td>$text{searchresults_nothingfound}</td></tr>\n");
}output(<<"EOT");
<tr>
<td>&nbsp</td>
</tr>
<tr>
<td align="center"><a href="$cgi&action=searchuser&text=$FORM{text}&position=$FORM{position}">$text{searchresults_again}</a></td>
</tr>
<tr>
<td align="center"><a href="$cgi&action=allusers">$text{usersearch_showall}</a></td>
</tr>
</table></td></tr>
EOT
printfooter("popup","{ROWS}",('{TITLE}' => $text{searchresults_title},
'{COMMENT}' =>$text{searchresults_comment}));
exitprog();
}1;
